/*
 * The contents of this file are subject to the terms 
 * of the Common Development and Distribution License 
 * (the License).  You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the license at 
 * https://glassfish.dev.java.net/public/CDDLv1.0.html or
 * glassfish/bootstrap/legal/CDDLv1.0.txt.
 * See the License for the specific language governing 
 * permissions and limitations under the License.
 * 
 * When distributing Covered Code, include this CDDL 
 * Header Notice in each file and include the License file 
 * at glassfish/bootstrap/legal/CDDLv1.0.txt.  
 * If applicable, add the following below the CDDL Header, 
 * with the fields enclosed by brackets [] replaced by
 * you own identifying information: 
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Copyright 2006 Sun Microsystems, Inc. All rights reserved.
 */
package com.sun.enterprise.tools.verifier.tests.ejb.session;

import com.sun.enterprise.tools.verifier.tests.ejb.EjbTest;
import java.util.logging.Level;

import com.sun.enterprise.tools.verifier.tests.*;
import com.sun.enterprise.deployment.EjbDescriptor;
import com.sun.enterprise.deployment.EjbSessionDescriptor;
import com.sun.enterprise.tools.verifier.*;
import com.sun.enterprise.tools.verifier.tests.ejb.EjbCheck;

/**
 * Optionally implements the SessionSynchronization Interface test.  
 * The optional SessionSynchronization interface may be implemented only by 
 * a stateful Session Bean using container-managed transactions. The 
 * SessionSynchronization interface must not be implemented by a stateless 
 * Session Bean. 
 */
public class SessionSynchronizationInterface extends EjbTest implements EjbCheck {

    /**
     * Optionally implements the SessionSynchronization Interface test.  
     * The optional SessionSynchronization interface may be implemented only by 
     * a stateful Session Bean using container-managed transactions. The 
     * SessionSynchronization interface must not be implemented by a stateless 
     * Session Bean. 
     *   
     * @param descriptor the Enterprise Java Bean deployment descriptor
     *   
     * @return <code>Result</code> the results for this assertion
     */
    public Result check(EjbDescriptor descriptor) {

        Result result = getInitializedResult();
        ComponentNameConstructor compName = getVerifierContext().getComponentNameConstructor();

        if (descriptor instanceof EjbSessionDescriptor) {
            String stateType = ((EjbSessionDescriptor)descriptor).getSessionType();
            try {
                Class c = Class.forName(descriptor.getEjbClassName(), false, getVerifierContext().getClassLoader());
                // walk up the class tree
                do {
                    //Class[] interfaces = c.getInterfaces();
                    //for (int i = 0; i < interfaces.length; i++) {
                    for(Class interfaces : c.getInterfaces()) {
                        logger.log(Level.FINE, getClass().getName() + ".debug1",
                                new Object[] {interfaces.getName()});

                        if (interfaces.getName().equals("javax.ejb.SessionSynchronization") ) {
                            String transactionType = descriptor.getTransactionType();
                            if ((EjbSessionDescriptor.STATELESS.equals(stateType)) ||
                                    ((EjbSessionDescriptor.STATEFUL.equals(stateType))
                                            && EjbSessionDescriptor.BEAN_TRANSACTION_TYPE
                                            .equals(transactionType) )) {
                                addErrorDetails(result, compName);
                                result.failed(smh.getLocalString
                                        (getClass().getName() + ".failed",
                                        "Error: [ {0} ] does not properly implement the SessionSynchronization interface. " +
                                        " SessionSynchronization interface must not be implemented by a stateless Session Bean. " +
                                        "[ {1} ] is not a valid bean.",
                                        new Object[] {descriptor.getEjbClassName(),descriptor.getEjbClassName()}));
                                break;

                            }
                        }
                    }
                } while ((c=c.getSuperclass()) != null);

            } catch (ClassNotFoundException e) {
                Verifier.debug(e);
                result.addErrorDetails(smh.getLocalString
                        ("tests.componentNameConstructor",
                                "For [ {0} ]",
                                new Object[] {compName.toString()}));
                result.failed(smh.getLocalString
                        (getClass().getName() + ".failedException",
                                "Error: [ {0} ] class not found.",
                                new Object[] {descriptor.getEjbClassName()}));
            }
        }

        if (result.getStatus()!=Result.FAILED) {
            addGoodDetails(result, compName);
            result.passed(smh.getLocalString(getClass().getName() + ".passed",
                    "The required interface is properly implemented"));
        }
        return result;
    }
}
